<!--
Please make this into a vue.js widget that displays a list of customers showing firstName, lastName, phone and email, and an action column.
Each column should be sortable, except the action column.
There should be a text input near the top that filters the results.
The only action required should be to delete a customer row.
Create dummy data that adequately showcases the features requested here.
If you open this file in a browser, it is set up to function as a standalone widget.
Feel free to make it look fancy, but it is not a requirement.
-->

<script src="https://cdn.jsdelivr.net/npm/vue"></script>
<script src="https://dev.opiniion.com/vue-custom-element.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/document-register-element/1.4.1/document-register-element.js"></script>

<script>
  Vue.customElement('test-widget', {
    data() {
      return {
        userArray: [
          {
            id: 1,
            email: 'george.bluth@reqres.in',
            phone: '+380501234567',
            firstName: 'George',
            lastName: 'Bluth',
            action: 'watch'
          },
          {
            id: 2,
            email: 'janet.weaver@reqres.in',
            phone: '+380501234568',
            firstName: 'Janet',
            lastName: 'Weaver',
            action: 'walk'
          },
          {
            id: 3,
            email: 'emma.wong@reqres.in',
            phone: '+380503434567',
            firstName: 'Emma',
            lastName: 'Wong',
            action: 'cycle'
          },
          {
            id: 4,
            email: 'eve.holt@reqres.in',
            phone: '+3805034245567',
            firstName: 'Eve',
            lastName: 'Holt',
            action: 'sleep'
          },
          {
            id: 5,
            email: 'charles.morris@reqres.in',
            phone: '+380123245567',
            firstName: 'Charles',
            lastName: 'Morris',
            action: 'run'
          },
          {
            id: 6,
            email: 'tracey.ramos@reqres.in',
            phone: '+3234034245567',
            firstName: 'racey',
            lastName: 'Ramos',
            action: 'walk'
          }
        ],
        valueToFilter: '',
        columnToSort: '',
        columnSortDir: 0,
      }
    },
    methods: {
      sortColumn(neededToSort) {
        const { columnSortDir, columnToSort } = this;
        if (columnToSort === neededToSort) {
          this.columnSortDir = columnSortDir === 1 ? -1 : 1;
          return
        }
        this.columnToSort = neededToSort;
        this.columnSortDir = 1;
      },
      deleteUser(userId) {
        const { userArray } = this;
        return this.userArray = userArray.filter((user) => {
          return user.id !== userId;
        })
      },
      skipSort() {
        this.columnSortDir = 0;
        this.columnToSort = '';
        this.valueToFilter = '';
      }
    },
    computed: {
      filteredUserArray() {
        const { valueToFilter, userArray, columnSortDir, columnToSort } = this;
        let sortedArray = [...userArray];
        if (valueToFilter || columnToSort) {
          sortedArray = sortedArray.filter((items) => {
            for (let item in items) {
              if(String(items[item]).indexOf(this.valueToFilter) !== -1) {
                return true
              }
            }
            return false
          })
          return sortedArray.sort((a,b) => {
            if (a[this.columnToSort] < b[this.columnToSort]) return -1 * columnSortDir;
            if (a[this.columnToSort] > b[this.columnToSort]) return 1 * columnSortDir;
            return 0;
          });
        }
        return userArray;
      }
    },
    template: `<div class="container">
        <h1>Users table</h1>
        <div>
          <input type="text" v-model="valueToFilter"/>  <button @click="skipSort">Skip sort </button>
        </div>
        <table class="custom-table">
          <thead>
            <tr>
              <th></th>
              <th @click="sortColumn('firstName')">User FirstName</th>
              <th @click="sortColumn('lastName')">User LastName</th>
              <th @click="sortColumn('phone')">User Phone</th>
              <th @click="sortColumn('email')">User Email</th>
              <th>User Action</th>
              <th></th>
            </tr>
          </thead>
          <tbody>
              <tr v-for="(user, index) in filteredUserArray" :key="user.id">
                <th>{{ index + 1 }}</th>
                <th>{{ user.firstName }}</th>
                <th>{{ user.lastName }}</th>
                <th>{{ user.phone }}</th>
                <th>{{ user.email }}</th>
                <th>{{ user.action }}</th>
                <th><button @click="deleteUser(user.id)">Delete user</button></th>
              </tr>
          </tbody>
        </table>
    </div>`
  });
</script>

<style>
.container {
  padding: 30px;
}

.custom-table {
  width: 100%;
  border: 1px solid #000;
  margin: 50px 0;
}

th {
  border: 1px solid #000;
  height: 50px;
}

thead>tr>th:hover {
  cursor: pointer;
  background: grey;
}
</style>

<html>
  <test-widget></test-widget>
</html>